diff -Nur linux-2.6.15.1/Makefile linux-2.6.15.1-zau/Makefile
--- linux-2.6.15.1/Makefile	2006-01-15 15:16:02.000000000 +0900
+++ linux-2.6.15.1-zau/Makefile	2006-01-26 23:20:00.000000000 +0900
@@ -193,6 +193,9 @@
 ARCH		?= $(SUBARCH)
 CROSS_COMPILE	?=
 
+ARCH		= arm
+CROSS_COMPILE	= arm-xscale-linux-gnu-
+
 # Architecture as present in compile.h
 UTS_MACHINE := $(ARCH)
 
diff -Nur linux-2.6.15.1/arch/arm/Kconfig linux-2.6.15.1-zau/arch/arm/Kconfig
--- linux-2.6.15.1/arch/arm/Kconfig	2006-01-15 15:16:02.000000000 +0900
+++ linux-2.6.15.1-zau/arch/arm/Kconfig	2006-01-28 20:37:07.000000000 +0900
@@ -517,6 +517,13 @@
 	  time by entering them here. As a minimum, you should specify the
 	  memory size and the root device (e.g., mem=64M root=/dev/nfs).
 
+config SHARPSL_BOOTLDR_PARAMS
+	bool "Use Sharp SL series bootloader parameter"
+	default n
+	help
+	  Use Sharp SL bootloader parameter. Use parameter at 0xa000100.
+
+
 config XIP_KERNEL
 	bool "Kernel Execute-In-Place from ROM"
 	depends on !ZBOOT_ROM
diff -Nur linux-2.6.15.1/arch/arm/mach-pxa/corgi.c linux-2.6.15.1-zau/arch/arm/mach-pxa/corgi.c
--- linux-2.6.15.1/arch/arm/mach-pxa/corgi.c	2006-01-15 15:16:02.000000000 +0900
+++ linux-2.6.15.1-zau/arch/arm/mach-pxa/corgi.c	2006-01-28 20:45:04.000000000 +0900
@@ -351,6 +351,9 @@
 	.init_irq	= pxa_init_irq,
 	.init_machine	= corgi_init,
 	.timer		= &pxa_timer,
+#ifdef CONFIG_SHARPSL_BOOTLDR_PARAMS
+        .boot_params    = 0xa0000100
+#endif
 MACHINE_END
 #endif
 
@@ -364,6 +367,9 @@
 	.init_irq	= pxa_init_irq,
 	.init_machine	= corgi_init,
 	.timer		= &pxa_timer,
+#ifdef CONFIG_SHARPSL_BOOTLDR_PARAMS
+        .boot_params    = 0xa0000100
+#endif
 MACHINE_END
 #endif
 
@@ -377,6 +383,9 @@
 	.init_irq	= pxa_init_irq,
 	.init_machine	= corgi_init,
 	.timer		= &pxa_timer,
+#ifdef CONFIG_SHARPSL_BOOTLDR_PARAMS
+        .boot_params    = 0xa0000100
+#endif
 MACHINE_END
 #endif
 
diff -Nur linux-2.6.15.1/arch/arm/mach-pxa/spitz.c linux-2.6.15.1-zau/arch/arm/mach-pxa/spitz.c
--- linux-2.6.15.1/arch/arm/mach-pxa/spitz.c	2006-01-15 15:16:02.000000000 +0900
+++ linux-2.6.15.1-zau/arch/arm/mach-pxa/spitz.c	2006-01-28 20:44:41.000000000 +0900
@@ -473,6 +473,9 @@
 	.init_irq	= pxa_init_irq,
 	.init_machine	= spitz_init,
 	.timer		= &pxa_timer,
+#ifdef CONFIG_SHARPSL_BOOTLDR_PARAMS
+        .boot_params    = 0xa0000100
+#endif
 MACHINE_END
 #endif
 
@@ -486,6 +489,9 @@
 	.init_irq	= pxa_init_irq,
 	.init_machine	= spitz_init,
 	.timer		= &pxa_timer,
+#ifdef CONFIG_SHARPSL_BOOTLDR_PARAMS
+        .boot_params    = 0xa0000100
+#endif
 MACHINE_END
 #endif
 
@@ -499,5 +505,8 @@
 	.init_irq	= pxa_init_irq,
 	.init_machine	= akita_init,
 	.timer		= &pxa_timer,
+#ifdef CONFIG_SHARPSL_BOOTLDR_PARAMS
+        .boot_params    = 0xa0000100
+#endif
 MACHINE_END
 #endif
diff -Nur linux-2.6.15.1/drivers/ide/legacy/ide-cs.c linux-2.6.15.1-zau/drivers/ide/legacy/ide-cs.c
--- linux-2.6.15.1/drivers/ide/legacy/ide-cs.c	2006-01-15 15:16:02.000000000 +0900
+++ linux-2.6.15.1-zau/drivers/ide/legacy/ide-cs.c	2006-01-29 01:10:41.000000000 +0900
@@ -452,11 +452,14 @@
 
 static struct pcmcia_device_id ide_ids[] = {
 	PCMCIA_DEVICE_FUNC_ID(4),
+	PCMCIA_DEVICE_PROD_ID12("BlankBlankBlankBlankBlankBlank", "blankblankblankblankblankblank", 0x0b9fa847f, 0x0b9fa847f),
+	PCMCIA_DEVICE_MANF_CARD(0x0007, 0x0000),	/* Hitachi */
 	PCMCIA_DEVICE_MANF_CARD(0x0032, 0x0704),
 	PCMCIA_DEVICE_MANF_CARD(0x0045, 0x0401),
 	PCMCIA_DEVICE_MANF_CARD(0x0098, 0x0000),	/* Toshiba */
 	PCMCIA_DEVICE_MANF_CARD(0x00a4, 0x002d),
 	PCMCIA_DEVICE_MANF_CARD(0x00ce, 0x0000),	/* Samsung */
+	PCMCIA_DEVICE_MANF_CARD(0x0319, 0x0000),
 	PCMCIA_DEVICE_MANF_CARD(0x2080, 0x0001),
 	PCMCIA_DEVICE_MANF_CARD(0x4e01, 0x0200),	/* Lexar */
 	PCMCIA_DEVICE_PROD_ID123("Caravelle", "PSC-IDE ", "PSC000", 0x8c36137c, 0xd0693ab8, 0x2768a9f0),
@@ -471,6 +474,8 @@
 	PCMCIA_DEVICE_PROD_ID12("EXP   ", "CD-ROM", 0x0a5c52fd, 0x66536591),
 	PCMCIA_DEVICE_PROD_ID12("EXP   ", "PnPIDE", 0x0a5c52fd, 0x0c694728),
 	PCMCIA_DEVICE_PROD_ID12("FREECOM", "PCCARD-IDE", 0x5714cbf7, 0x48e0ab8e),
+	PCMCIA_DEVICE_PROD_ID12("HITACHI", "FLASH", 0xf4f43949, 0x9eb86aae),
+	//	PCMCIA_DEVICE_PROD_ID12("HITACHI", "microdrive", 0xf4f43949, 0xa6d76178),
 	PCMCIA_DEVICE_PROD_ID12("IBM", "IBM17JSSFP20", 0xb569a6e5, 0xf2508753),
 	PCMCIA_DEVICE_PROD_ID12("IO DATA", "CBIDE2      ", 0x547e66dc, 0x8671043b),
 	PCMCIA_DEVICE_PROD_ID12("IO DATA", "PCIDE", 0x547e66dc, 0x5c5ab149),
@@ -482,6 +487,7 @@
 	PCMCIA_DEVICE_PROD_ID12("SHUTTLE TECHNOLOGY LTD.", "PCCARD-IDE/ATAPI Adapter", 0x4a3f0ba0, 0x322560e1),
 	PCMCIA_DEVICE_PROD_ID12("TOSHIBA", "MK2001MPL", 0xb4585a1a, 0x3489e003),
 	PCMCIA_DEVICE_PROD_ID12("WIT", "IDE16", 0x244e5994, 0x3e232852),
+	PCMCIA_DEVICE_PROD_ID123("KODAK Picture Card       ", "KODAK  ", "V100K", 0x94a0d8f3, 0xe4fc3ea0, 0xe5e7eed4),
 	PCMCIA_DEVICE_PROD_ID1("STI Flash", 0xe4a13209),
 	PCMCIA_DEVICE_PROD_ID12("STI", "Flash 5.0", 0xbf2df18d, 0x8cb57a0e),
 	PCMCIA_MFC_DEVICE_PROD_ID12(1, "SanDisk", "ConnectPlus", 0x7a954bd9, 0x74be00c6),
@@ -511,5 +517,55 @@
 	BUG_ON(dev_list != NULL);
 }
 
+int ide_cs_cmdline(char *cmdline)
+{
+  char *s = cmdline;
+  int i = 0, j = 0, e = 0;
+  char extra_ids[4][30];
+
+  printk("ide_cs: param  %s\n",s);
+  
+  for(;;){
+    if(s[j] == ',' || s[j] == '\0'){
+
+      if( j <= 1){
+
+	printk("ide_cs param: Bad parameter.\n");
+	return 0;
+
+      }else if( j >= 30){
+
+	printk("ide_cs param: Bad parameter.\n");
+	return 0;
+
+      }else {
+
+	strncpy(extra_ids[e], s, j );
+	extra_ids[e][j] = '\0';
+	e++;
+	s += j+1;
+	j = 0;
+	if(e >= 4)
+	  break;
+      }
+    }    
+    j++;
+  }      
+  
+  printk("ide_cs: Good parameter.\n");
+
+  memset(ide_ids[1].prod_id[0] , 0, 30);
+  memset(ide_ids[1].prod_id[1] , 0, 30);
+  strncpy(ide_ids[1].prod_id[0], extra_ids[0], strlen(extra_ids[0])+1);
+  strncpy(ide_ids[1].prod_id[1], extra_ids[1], strlen(extra_ids[1])+1);
+  ide_ids[1].prod_id_hash[0] = simple_strtoul(extra_ids[2], NULL, 16);
+  ide_ids[1].prod_id_hash[1] = simple_strtoul(extra_ids[3], NULL, 16);
+
+
+  return 1;
+}
+
+__setup("cs_ide=", ide_cs_cmdline);
+
 late_initcall(init_ide_cs);
 module_exit(exit_ide_cs);
diff -Nur linux-2.6.15.1/drivers/video/console/fbcon.c linux-2.6.15.1-zau/drivers/video/console/fbcon.c
--- linux-2.6.15.1/drivers/video/console/fbcon.c	2006-01-15 15:16:02.000000000 +0900
+++ linux-2.6.15.1-zau/drivers/video/console/fbcon.c	2006-01-26 23:23:47.000000000 +0900
@@ -132,8 +132,13 @@
 static int info_idx = -1;
 
 /* console rotation */
+#ifdef CONFIG_FRAMEBUFFER_CONSOLE_ROTATION
+static int rotate = 1;
+#else
 static int rotate;
 
+#endif
+
 static const struct consw fb_con;
 
 #define CM_SOFTBACK	(8)
